// Demonstracni priklad pouziti displeje PKDM-10 na adrese 8F

#use "compact.lib"	// pro SBPS-02
//#use "pmscpu.lib"	// pro SBPS-01

#use "pkdm.lib"		// pro PKDM-10

#define  N 20
#define NIGHT '*'
#define  LIT 20
#define PKDMADR (0x8f)
#define PKDMINTPER 573
main() {
     int i,j,k,a;
     inport(0x7f);				// zhasnu podsvit
     outport(PKDMADR,0xF5);	// uvolneni PKDM 10
     lk_init(PKDMADR);        // inicializace kontroleru LCD
     lk_init_keypad(PKDMADR); // inicializace kontroleru LCD
     lk_printf("\x1b0"); 		// zhasnuti kurzoru 
     for(;;) {
       flush(10); wait(50);
       lk_setbeep(70);
       present("    ELSACO group    ","    presents ...    ",20);
       present("     Universal      ","  microcontroller   ",20);
       present("  based on Z-World  ","     SmartBlock     ",20);
       present("   with advanced    ","   I/O subsystem    ",20);
       present("   Bit I/O:         ","   total 40 lines   ",20);
       present("  4 Serial channel  ","    RS232/422/485   ",20);
       present("  One printer port  ","     CENTRONICS     ",20);
       present("    One port for    ","  KBD & LCDdisplay  ",20);
       present("  Serial&parallel   ","   expansion slot   ",20);
       present("   and many many    ","    others ...      ",20);
       present("    Call ELSACO     ","      0321 27753    ",25);
       lk_setbeep(70);
       delay(1000);
    }
}

present(char*p1, char*p2, int w) {
   int i,j,k,l,m;
   for(m=0,i=0; i<N/2; i++) {
     j=N/2-i-1; k=N/2+i; l=i+i;
     lputc(0xC0+j); back(l); lk_putc (*(p1+j)); back(l);
     lputc(0xC0+k); back(l); lk_putc (*(p1+k)); back(l);
     l++;
     lputc(0x94+j); back(l); lk_putc (*(p2+j)); back(l);
     lputc(0x94+k); back(l); lk_putc (*(p2+k)); back(l);
     if(i&1)m=(m<<1)+1;
     lk_setled(m&0xf);
   }
   outport(PKDMADR,0x4);
   wait (w);
   indic();
   for(i=N/2-1; i>=0; i--) {
     j=N/2-i-1; k=N/2+i; l=i+i;
     lputc(0xC0+j); back(l); lk_putc (NIGHT); back(l);
     lputc(0xC0+k); back(l); lk_putc (NIGHT); back(l);
     l--;
     lputc(0x94+j); back(l); lk_putc (NIGHT); back(l);
     lputc(0x94+k); back(l); lk_putc (NIGHT); back(l);
     if(i&1)m=(m>>1);
     lk_setled(m&0xf);
   }  
}

flush (int w) {
   int i;
   lputc(0xC0); for(i=0; i<N; i++) lk_putc(NIGHT);
   lputc(0x80); for(i=0; i<N; i++) lk_putc(NIGHT);
   lputc(0x94); for(i=0; i<N; i++) lk_putc(NIGHT);
   lputc(0xD4); for(i=0; i<N; i++) lk_putc(NIGHT);
}  

indic() {
   int j,i; char ch, c,x;
   c=0;
   outport (0x4b, 0x05);
   if (c) { outport (0x4B, 0xEA); c=0; }
   else   { outport (0x4B, 0x6A); c=1; }
   for (ch=0xFE, i=0; i<7; i++) {
      outport (0x76, ch); ch= ch<<1; ch|=1; x = inport (0x76);
      wait(1);
   }
   outport (0x4b, 0x05);
   if (c) { outport (0x4B, 0xEA); c=0; }
   else   { outport (0x4B, 0x6A); c=1; }
   for (ch=0x7F, i=0; i<8; i++) {
     outport (0x76, ch); ch = ch>>1; ch|=0x80; x = inport(0x76);
     wait(1);
   }
}

back(int c){
	int b;
	unsigned a;
	if(c<2){
		inport(0x7f);
		return(0);
	}
	if(c==20){
		outport(0x7f,0);
		return(0);
	}
	outport(0x7f,0);
	for(b=0;b<20;b++){
		if(c==b)inport(0x7f);
		for(a=0;a<15;a++);
	}
	if(c>9)outport(0x7f,0);
	else inport(0x7f);
}

wait(unsigned int n) {
  unsigned int i;
  for(i=0; i<n*1000; i++) ;
}
