/*=== Promos SBPS-01 ==============================================================
 Prenasi obsah portu PA (vstupni) na LED portu PC
   Program neni urcen pro prakticke vyuziti, 
   spise je demonstrovana moznost vyvolani INT1 od vnejsiho signalu.
   Pro snadne generovani signalu, ktery vyvolava preruseni je pouzit
   signal STBQ.
   Stav portu PA je strobovan signalem STBQ 1x za 500ms, preruseni je
   vyvolano vzdy zapisem _STBQ (imitace ext. Strobe). Shozeni pozadavku na 
   preruseni (klopny obvod na desce SBPS) se provede v prerusovaci rutine 
   ctenim portu PA.
   obdobny mechanizmus je mozne pouzit i pro port PB.
 Nastaveni propojek:
   Propojka X7 - spojeny piny 2-3 (port PC vystupni)
   Propojka X4 - spojeny piny 1-2 (pripojeni INT1) a 3-4 (strobovani STBQ) 
*/

#use "pmscpu.lib"	

main() {
   inport (_PADIR);          // nastaveni PA na vstup
   enb_int1();               // povoleni INT1 v ITC reg
   EI();
   for (;;) {
      delay(500);
      outport (_STBQ,0);     // zachyceni stavu (STBQ=0) - zde se vyda INT1
      inport(_STBQ);         // 
   }
}

#INT_VEC INT1_VEC pa_stb_isr // vektor pro obsluhu preruseni INT1

interrupt pa_stb_isr() {
  char x;
  x=inport(_PAD);      // sejmuti stavu portu PA a zruseni INT
  outport(_PCD,x);     // vypis PA na PC - sviti bity, ktere jsou v 0
}

// alternativni obsluzna rutina v asembleru
/*
#memmap push root
#asm
pa_stb_isr::
  push af         ; ulozeni af
  in0 a,(_PAD)    ; sejmuti PA
  push af
  in0 a,(_STBQ)   ; shozeni STBQ
  pop af
  out0 (_PCD),a   ; vypis na PC
  pop af          ; obnova a navrat
  ei
  ret
#endasm
#memmap pop
*/
