
/******************************************************************

      SIODEMO0.C

      Little Giant & Promos SBPS-01

   Demo of serial driver for SIO channel A of the KIO.

   Little Giant:   Connect J8 5-3, RS-232 (RX/TX)
   Promos SBPS-01: Connect 4-5 on TTL side of piggyBack PB2 (Rx/Tx)

   This will loop the serial port back on itself so that the signal
   that is sent is received on the same port.  Z-World serial drivers
   are interrupt driven and continue to run while the program executes.

*****************************************************************/

#use "pmscpu.lib"
#use "pmsser.lib"

char buf[]="This message sent over serial line!";
char cc;       /* down counter for transmitter */

char rbuf[50]; /* receive buffer */
char rcc;      /* receiver down counter */

main()
{
   int  tt;                    /* time out counter */

   setdaisy (1);               /* set KIO interrupt priorities, SIO 1st */
   ser_init_s0 (4,12/12);    /* setup serial port */
   cc = sizeof (buf);          /* number of character to send */
   rcc = cc;                   /* receive the same number of characters */
   rbuf[0] = 0;                /* in case print null string */

   ser_rec_s0(rbuf,&rcc);      /* get ready to receive characters */
   ser_send_s0(buf,&cc) ;      /* OK now we can send the string */

   EI();                       /* make sure that interrupts are enabled */
   tt=0;                       /* time out counter */
   while (rcc && --tt);        /* wait for receive count = 0 or time out */

   if(!tt)
      printf("Timed out - port not loop connected?\n");

   printf("%s\n",rbuf);

   ser_kill_s0();
}

/***********************************************End of SIODEMO0.C *****/

