/* ===== Promos ====================================================
 Demonstracni program pripojeni tiskarny Centronics na CPIO.

 Tiskarna je pripojena na port XC4 kabelem dle obrazku v Popisu centralni 
 jednotky. 
 Funkce prn_init nastavi konfiguraci portu CPIO, funkce prn_reset inicializuje
 (reset) tiskarnu (neni bezpodminecne nutne). Funkce prn_char vraci 0, pokud 
 je znak prenesen do tiskarny. Timeout (parametr funkce prn_init) je mozne 
 nastavit podle potreby, doba je priblizne v ms. Funkce prn_char obnovuje
 WatchDog. Po vyprseni Timeout vraci -1 (plny buffer) nebo -2 (chyba, 
 offline, konec papiru ap.). 
*/

#use "pmscpu.lib"

main() {
  int i,j;

  prn_init (4000);          // inicializace, Timeout 4 s
  prn_reset();              // reset tiskarny
  for(j=32;j<32+60;j++) {   // kravatovy tisk 60 linek
    for (i=j; i<j+80; i++) 
      if(i==0x7F) ppr(' '); // vynechani znaku DEL
      else ppr(i);
    ppr(0x0d); ppr(0x0a);   // novy radek
  }
} 

ppr(int c) {
  int stat;
  for(;;) {
     if(!prn_char(c)) return;                   // 0..znak odeslan OK
     stat=prn_stat();                           // stavove slovo 
     printf("\nTimeout! \a");
     if(!BIT(&stat,4))  printf("Error ");
     if(!BIT(&stat,5))  printf("OffLine ");
     if( BIT(&stat,6))  printf("PaperEmpty ");
     if( BIT(&stat,7))  printf("BUSY ");
  }
}

