/***************************************************************

   SER0_DEM.C

   Little Giant, Tiny Giant, Protocol Switch, SmartBlock

   SmartBlock & Promos SBPS-01:
      connect 4-5 on TTL side of PiggyBack PB1 (Rx/Tx)

   This will loop the serial port back on itself so that the signal
   that is sent is received on the same port.  Z-World serial drivers
   are interrupt driven and continue to run while the program executes.

**********************************************************************/
#use "pmscpu.lib"
#use "pmsser.lib"

char buf[] = "This message sent over serial line!";
char cc;             /* transmit buffer down counter */

char rbuf[50];       /* receive buffer */
char rcc;            /* receive buffer down counter */

main()
{
   int  tt;                    /* time out counter */

   ser_init_z0(4,9600/1200);  /* setup serial port, 8 bits, no parity */
   cc=sizeof(buf);            /* get number of characters to send */
   rcc=cc;                    /* make it the number of characters to receive */
   rbuf[0]=0;                 /* in case print null string */

   ser_rec_z0(rbuf,&rcc);     /* make sure receiver is ready */
   ser_send_z0(buf,&cc);      /* OK, now send the string */

   tt=0;
   while (rcc && --tt);       /* wait for receive counter to 0 or time out */

   if(!tt) 
      printf("Timed out - port not loop connected?\n");
   printf("%s\n",rbuf);
}

/*********************************************End of SER0_DEM.C *****/


