/***************************************************************

   SER1_DEMO.C

   Little Giant, Tiny Giant, Protocol Switch, SmartBlock & Promos

   Demonstration of serial port driver for Z180 ASCI port 1. 
   
   SmartBlock & Promos SBPS-01:
      Connect 3-5 XC3 (RS232 Rx/Tx)

   This will loop the serial port back on itself so that the signal
   that is sent is received on the same port.  Z-World serial drivers
   are interrupt driven and continue to run while the program executes.

**********************************************************************/

#use "pmscpu.lib"
#use "pmsser.lib"

char buf[] = "This message sent over serial line!";
char cc;       /* send buffer counter */
char rbuf[50]; /* receive buffer */
char rcc;      /* receive buffer counter */

main()
{
   int  tt;    /* timeout counter */

   ser_init_z1 (4, 9600/1200);  /* setup serial port 8 bits, no parity */

   cc = sizeof(buf);            /* get number of characters to send */
   rcc = cc;                    /* going to receive the same number */

   rbuf[0]=0;                   /* in case print null string */

   ser_rec_z1 (rbuf,&rcc);      /* get receiver ready before sending */
   ser_send_z1 (buf,&cc);       /* OK, now start the transmitter */

   tt=0;                        /* a little hocus pocus */
   while (rcc && --tt);         /* wait for receive count = 0 or timeout */

   if (!tt)                     /* if tt == 0 then timed out */
      printf("Timed out - port not loop connected?\n");
   printf("%s\n",rbuf);
}

/*************************************************End of SER_DEMO.C ****/

